Subject: Re: [sacm] Requested late modifications to the SWIMA specification

From: "Nancy Cam-Winget (ncamwing)" <[email-masked]>
Date: Thu, 24 May 2018 02:16:03 +0000

I’m OK with the suggested updates; and agree that I think the guidelines need to be consistant to what is mentioned
In Section 10 (or perhaps make a broader guidelines section that then Section 10 references) as well as consistency with 
RFC 5792 (and RFC 8126 the updated general guidelines).

But I have a question on the attributes change (see further below):

On 5/21/18, 2:07 PM, "Eric Voit (evoit)" <[email-masked]> wrote:

    Agree with Ira.   These seem like two reasonable changes.   While building out the expert guidelines, it might be useful to make some connection to of this new section from Section 10.4 (Registry for Software Data Models) which also makes reference to expert review.
    
    Eric

    From, Ira McDonald, Sat, 19 May 2018 12:10 
    
    Hi Charles,
    
    I agree with both proposed changes.
    
    Thanks for your diligent work on this spec.
    
    Cheers,
    - Ira

    Ira McDonald (Musician / Software Architect)
    Co-Chair - TCG Trusted Mobility Solutions WG
    Chair - Linux Foundation Open Printing WG
    Secretary - IEEE-ISTO Printer Working Group
    Co-Chair - IEEE-ISTO PWG Internet Printing Protocol WG
    IETF Designated Expert - IPP & Printer MIB
    Blue Roof Music / High North Inc
    http://sites.google.com/site/blueroofmusic
    http://sites.google.com/site/highnorthinc
    mailto: mailto:[email-masked]
    Jan-April: 579 Park Place  Saline, MI  48176  734-944-0094
    May-Dec: PO Box 221  Grand Marais, MI 49839  906-494-2434

    On Fri, May 18, 2018 at 4:27 PM, Schmidt, Charles M. <mailto:[email-masked]&gt;
    wrote:
    
    > Hello,
    >
    > SWIMA is nearing finalization. However, there have been requests for some
    > late changes to the document that would have a normative impact. Benjamin
    > Kaduk (AD) indicated he is willing to consider allowing these changes
    > without requiring a restart of the review process, but only if there are no
    > objections from the working group. Both of these changes are such that
    > making them will improve the standard, but neither are required for a
    > functional standard and SWIMA can be finalized without either change if
    > members of the workgroup object to those changes.
    >
    > Briefly, the requested changes are:
    > 1) Add a section to the document's IANA considerations containing
    > "Designated Expert Guidelines" for the Registry for Software Data Models
    > that SWIMA defines. This section would follow the template of the
    > Designated Expert Guidelines in section 7.1 of RFC 5792 (PA-TNC) and
    > section 6.1 of RFC 5793 (PB-TNC). These guidelines contain normative text:
    > values MUST be useful, not harmful to the Internet, and support
    > interoperability; and referenced documents in the IANA tables MUST be made
    > permanently available.
    > 2) For both the Software Identifier Inventory and Software Inventory
    > attributes, add an 8-byte "Reserved" field between the Source ID Number and
    > Software Identifier Length fields in the message. This would make all four
    > types of Response Attributes have a long segment of the same fields in the
    > same order, which would simplify parser implementation. Currently Event
    > attributes and Inventory attributes have a segment of fields that are the
    > same EXCEPT that Event attributes have an 8-byte Action field between the
    > Source ID Number and Software Identifier Length fields, which is absent in
    > Inventory attributes.
[NCW] In looking at the sub-block formats for the software inventory attrs vs
The Events attrs, I am not seeing that much similarity in fields other than your
Request to make the 3-tuple <source ID #, reserved/action, sw id length> be
"similar"....I say similar because in the Event, you still need to know to retain
The "action".....but the general parsing implementation still needs to parse
The pre- and post- fields ....so I am not seeing an optimization or simplification?

    >
    > We will not make any change for which there are objections from the
    > workgroup, and SWIMA's function will not be hindered by the absence of
    > these changes. That said, I do feel that the changes would both benefit
    > future IANA expert reviewers and implementers, respectively.
    >
    > I am aware of two implementations of SWIMA (by Andreas Steffan and
    > Carl-Heinz Genzel), and both are supportive of the field change in item #2.
    >
    > Please let me know if you have any questions or concerns, and definitely
    > speak up if you have an objection to either of these changes.
    >
    > Thanks,
    > Charles
    >
    > _______________________________________________
    > sacm mailing list
    > mailto:[email-masked]
    > https://www.ietf.org/mailman/listinfo/sacm
    >
    
    _______________________________________________
    sacm mailing list
    [email-masked]
    https://www.ietf.org/mailman/listinfo/sacm

---

From: "Schmidt, Charles M." <[email-masked]>
Date: Thu, 24 May 2018 18:29:54 +0000

Hi Nancy,

Thanks for looking at this. I'll make sure to keep the expert guidance consistent with the examples and advice. (I'm lazy - I'll copy and paste as much as possible. :)

> The pre- and post- fields ....so I am not seeing an optimization or

In fact, the block of similar fields is much larger: it runs from the Record Identifier all the way through the Software Locator. In the diagram, this is 20 bytes, but since two of the fields in that range are variable size, it is likely to be larger than this in practice. 

You are correct that it will require different treatment of the Action/Reserved byte, but as far as the code to parse the bit-stream into dedicated fields, that code will be the same. (You just won't bother looking at one of the fields you parsed into for Inventory messages.) Yes - it isn't a big enhancement, but I think it still qualifies as an enhancement.

Thank you (and everyone else who has chimed in) for your comments. Please let me know if you have additional questions.

Charles

> -----Original Message-----
> From: sacm [mailto:[email-masked]] On Behalf Of Nancy Cam-
> Winget (ncamwing)
> Sent: Wednesday, May 23, 2018 10:16 PM
> To: Eric Voit (evoit) <[email-masked]>; [email-masked]
> Subject: Re: [sacm] Requested late modifications to the SWIMA specification
> 
> In Section 10 (or perhaps make a broader guidelines section that then Section
> 10 references) as well as consistency with
>     Agree with Ira.   These seem like two reasonable changes.   While building
> out the expert guidelines, it might be useful to make some connection to of
> this new section from Section 10.4 (Registry for Software Data Models) which
> also makes reference to expert review.
> 
>     Eric
> 
>